-module(kiv).
-compile(export_all).
-author('kapolnai@iit.bme.hu, hanak@iit.bme.hu, genExc is inspired by "J.Armstrong: Programming Erlang. The Pragmatic Bookshelf, 2007."').
-vsn('$LastChangedDate: 2019-10-29 21:47:55 +0100 (k, 29 okt 2019) $$').

-spec safe_apply(Fun::fun((Arg::term()) -> Val::term()), Arg::term()) -> Res::{ok, Val::term()} | error.
%% Ha Fun(Arg) hibát dob, Res == error, különben Res == {ok, Fun(Arg)}.
%% A legsúlyosabb, 'exit' típusú hibát nem kapja el.
safe_apply(Fun, Arg) ->
    try Fun(Arg) of
        V -> {ok, V}
    catch
        throw:_Why -> error;
        error:_Why -> error % például error:function_clause
    end.

-type enVal() :: 1|2|3|4.
-spec genExc(A::term(), S::enVal()) -> A::term() | no_return().
genExc(A,1) -> A;
genExc(A,2) -> throw(A);
genExc(A,3) -> exit(A);
genExc(A,4) -> error(A).

-spec tryGenExc(A::term(), S::enVal()) -> R::{S::enVal(), M::atom(), A::term()}.
tryGenExc(X,I) ->
    try genExc(X,I) of
        Val -> {I, 'Lefutott', Val}
    catch
        throw:X -> {I, 'Kivetelt dobott', X};
        exit:X  -> {I, 'Befejezodott', X};
        error:X -> {I, 'Sulyos hibat jelzett', X}
    end.

% [ kiv:tryGenExc(X,I) || {X,I} <- [{'No',1},{'Th',2},{'Ex',3},{'Er',4}] ].
% [ catch kiv:genExc(X,I) || {X,I} <- [{'No',1},{'Th',2},{'Ex',3},{'Er',4}] ].

fej(L) -> hd(L).
fejplusz1(L) -> fej(L)+1.

teszt() -> try kiv:fejplusz1([]) catch error:badarg -> erlang:get_stacktrace() end.
