-module(trees).
-author('hanak@emt.bme.hu').
-vsn('2020-10-25').
%-export([...]).
-compile(export_all).

-type btree() :: lf | {btree(), any(), btree()}.
-spec bt_to_list(BT :: btree()) -> Ls :: [any()].
bt_to_list(lf) ->
    [];
bt_to_list({Bt, V, Jt}) ->
    [ V | bt_to_list(Bt) ] ++ bt_to_list(Jt).

-type ttree() :: lf | {ttree(), ttree(), ttree(), any()}.
-spec tt_to_list(TT :: ttree()) -> Ls :: [any()].
tt_to_list(lf) ->
    [];
tt_to_list({Bt, Mt, Jt, V}) ->
    [ V | tt_to_list(Bt) ] ++ tt_to_list(Mt) ++ tt_to_list(Jt).

-type ltree() :: lf | {any(), [ltree()]}.
-spec lt_to_list(LT :: ltree()) -> Ls :: [any()].
lt_to_list(lf) ->
    [];
lt_to_list({V, Ts}) ->
    [ V | lists:append(lists:map(fun lt_to_list/1, Ts)) ].

test() ->
    BT1 = {lf,a,lf},
    BT2a = {
	    {lf,c,lf},
	    b,
	    lf
	   },
    BT2b = {
	    lf,
	    e,
	    {lf,f,lf}
	   },
    BT2c = {
	    {lf,h,lf},
	    g,
	    {lf,i,lf}
	   },
    BT2 = {
	   BT2a,
	   a,
	   {
	    BT2b,
	    d,
	    BT2c
	   }
	  },
    TT1 = {lf,lf,lf,a},
    TT2a = {
	    {lf,lf,lf,c},
	    lf,
	    lf,
	    b
	   },
    TT2b = {
	    lf,
	    {lf,lf,lf,f},
	    lf,
	    e
	   },
    TT2c = {
	    {lf,lf,lf,h},
	    lf,
	    {lf,lf,lf,i},
	    g
	   },
    TT2 = {
	   TT2a,
	   TT2b,
	   TT2c,
	   a
	  },
    LT1 = {a, []},
    LT2a = {b, [{c, [lf,lf,lf]}, lf, lf]},
    LT2b = {e, [lf, {f, [lf,lf,lf]}, lf]},
    LT2c = {g, [{h, [lf,lf,lf]}, lf, {i, [lf,lf,lf]}]},
    LT2 = {a, [LT2a, LT2b, LT2c]},
    [ bt_to_list(BT1),
      bt_to_list(BT2),
      tt_to_list(TT1),
      tt_to_list(TT2),
      lt_to_list(LT1),
      lt_to_list(LT2)
    ].
